# RefitWindow Struct Reference

Refit cargo window. More...

Inheritance diagram for RefitWindow:

## Public Member Functions
| RefitWindow (const WindowDesc *desc, const Vehicle *v, VehicleOrderID order)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnDoubleClick (Point pt, int widget)
| A double click with the left mouse button has been made on the window.
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
## Data Fields
int | sel
| Index in refit options, `-1` if nothing is selected.
RefitOption * | cargo
| Refit option selected by sel.
RefitList * | list
| List of cargo types available for refitting.
uint | length
| For trains, the number of vehicles.
VehicleOrderID | order
| If not INVALID_VEH_ORDER_ID, selection is part of a refit order (rather than execute directly).

## Detailed Description

Refit cargo window.

Definition at line 371 of file vehicle_gui.cpp.

## Member Function Documentation

virtual void RefitWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 404 of file vehicle_gui.cpp.

References VEH_TRAIN.

virtual void RefitWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 426 of file vehicle_gui.cpp.

References FONT_HEIGHT_NORMAL, Dimension::height, WD_MATRIX_BOTTOM, and WD_MATRIX_TOP.

virtual void RefitWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 436 of file vehicle_gui.cpp.

References SetDParam().

virtual void RefitWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 441 of file vehicle_gui.cpp.

References Rect::bottom, CmdSucceeded(), DC_QUERY_COST, DoCommand(), DrawStringMultiLine(), DrawVehicleRefitWindow(), CommandCost::GetCost(), Rect::left, Rect::right, SetDParam(), Rect::top, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void RefitWindow::OnDoubleClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A double click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 464 of file vehicle_gui.cpp.

virtual void RefitWindow::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 469 of file vehicle_gui.cpp.

References CMD_ORDER_REFIT, DoCommandP(), INVALID_VEH_ORDER_ID, Point::y, and GetNewVehiclePosResult::y.

virtual void RefitWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 495 of file vehicle_gui.cpp.

References MAT_COL_START, and MAT_ROW_START.

The documentation for this struct was generated from the following file:

- src/vehicle_gui.cpp